-- O
local setting
local outputDir, imageDir, isTrim, compressLevel
for line in io.lines("arguments.txt") do
    -- ݒ̓ǂݍ
    if setting == nil then
        setting = {}
        for key, value in string.gmatch(line, "([^\x09=]+)=([^\x09]*)") do
            setting[key] = value
        end
        -- ݒ̎擾
        outputDir = setting["outputDir"]
        imageDir = setting["imageDir"]
        isTrim = setting["isTrim"]
        compressLevel = setting["compressLevel"]
    end
end
-- ݒt@C폜
local success, args = pcall(os.remove("arguments.txt"))

-- 摜o
local outputFile = function (num, fileName)
    -- ̍폜
    if isTrim == "1" then
        trimmingImage(num, "UDLR")
    end
    -- 摜̏o͂Ɖ
    local outputFileName = outputDir .. string.gsub(fileName, "/", "\\") .. ".png"
    saveImage(num, outputFileName, 1, 0, tonumber(compressLevel), 0)
    freeImage(num)
    print("output: " .. outputFileName .. "\n")
end

-- 摜
local list = getFileList(imageDir, "*.png", 1)
local len = string.len(imageDir) + 1
local progressFileName
local progressNum = 1
for i, imagePath in ipairs(list) do
    -- t@C̎擾
    local subDir = getParentFolderName(string.sub(imagePath, len))
    subDir = (subDir == "") and "\\" or subDir
    local currentFileName = subDir .. string.match(getBaseName(imagePath), "^([^+]+)%+")
    if currentFileName ~= nil then
        if progressFileName ~= currentFileName then
            -- t@Co
            if existImage(progressNum) == 1 then
                outputFile(progressNum, progressFileName)
            end
            progressFileName = currentFileName
            createImage(progressNum, 1, 1, 0x000000ff)
        end

        -- 摜ǂݍ
        loadImage(0, imagePath)
        local partWidth, partHeight = getSizeImage(0)
        -- ݂̏o̓t@CTCY̎擾
        local outputWidth, outputHeight = getSizeImage(progressNum)
        outputHeight = (outputHeight ~= 1) and outputHeight or 0
        -- \tʒu̎擾
        local pastePosX = tonumber(string.match(imagePath, "x([0-9]+)[^\\/]+.png$"), 10)
        local pastePosY = outputHeight
        -- o̓t@CTCY̐ݒ
        if partWidth + pastePosX > outputWidth then
            outputWidth = partWidth + pastePosX
        end
        outputHeight = outputHeight + partHeight
        -- 摜̍
        local nextNum = (progressNum + 1 ~= 1000) and progressNum + 1 or 1
        createImage(nextNum, outputWidth, outputHeight, 0x000000ff)
        blendImage(nextNum, progressNum, 1, 0, 0)
        blendImage(nextNum, 0, 1, pastePosX, pastePosY)
        freeImage(progressNum)
        progressNum = nextNum
    end
end
-- ŏIt@C̏
if nextNum ~= 0 then
    outputFile(progressNum, progressFileName)
end
